## cvise 2.7.0

=== CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019 The University of Utah
## All rights reserved.
##
## This file is distributed under the University of Illinois Open Source
## License.  See the file COPYING for details.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(CheckIncludeFile)
include(CheckCXXCompilerFlag)
include(GetGitRevisionDescription)

project(cvise)

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
  message(FATAL_ERROR "CMAKE_SOURCE_DIR should be different from PROJECT_BINARY_DIR")
endif()

###############################################################################

# Locate LLVM and check its version.  Do this here because we need the LLVM
# package definitions in the "CMakeLists.txt" files for multiple subdirs.
#
find_package(LLVM REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
message(STATUS "Using LLVMConfig.cmake in ${LLVM_DIR}")
if (${LLVM_PACKAGE_VERSION} VERSION_LESS "9.0")
  message(FATAL_ERROR "C-Vise requires LLVM 9.0 or later")
endif()
#
# Do this here, too, just to keep it with the LLVM check above.
#
find_package(Clang REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
message(STATUS "Using ClangConfig.cmake in ${Clang_DIR}")

# Locate Python and check its version.
#
find_package(PythonInterp 3.6 REQUIRED)

# Locate pytest
execute_process(COMMAND ${PYTHON_EXECUTABLE} -m pytest --version
  OUTPUT_VARIABLE PYTEST_output
  ERROR_VARIABLE  PYTEST_error
  RESULT_VARIABLE PYTEST_result)
if(NOT ${PYTEST_result} EQUAL 0)
  message(WARNING "Pytest package not available: ${PYTEST_error}")
endif()

# Locate Pebble
execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import pebble"
  OUTPUT_VARIABLE PEBBLE_output
  ERROR_VARIABLE  PEBBLE_error
  RESULT_VARIABLE PEBBLE_result)
if(NOT ${PEBBLE_result} EQUAL 0)
  message(WARNING "Pebble package not available: ${PEBBLE_error}")
endif()

# Locate psutil
execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import psutil"
  OUTPUT_VARIABLE PSUTIL_output
  ERROR_VARIABLE  PSUTIL_error
  RESULT_VARIABLE PSUTIL_result)
if(NOT ${PSUTIL_result} EQUAL 0)
  message(WARNING "psutil package not available: ${PSUTIL_error}")
endif()

# Locate flex.  Do this here because we need the package definitions in the
# "CMakeLists.txt" files for multiple subdirs.
#
find_package(FLEX REQUIRED)

find_program(UNIFDEF unifdef)
if(NOT UNIFDEF)
  message(WARNING "unifdef not available")
endif()

###############################################################################

# Determine the short git hash for the source tree.
#
## METHOD 1: The source tree is the result of `git archive'.
# `git archive' inserts the abbreviated hash of the archive's commit into this
# file.  (See the `.gitattributes' file.)
#
set(GIT_HASH "d9e4a505")
if(GIT_HASH MATCHES "^\\$")
  ## METHOD 2: The source tree is a git repository.
  get_git_head_revision(GIT_REFSPEC GIT_HASH)
  if(NOT GIT_HASH STREQUAL "GITDIR-NOTFOUND")
    # Trim to the short hash.
    string(SUBSTRING "${GIT_HASH}" 0 7 GIT_HASH)
  else()
    ## METHOD 3: Give up.
    set(GIT_HASH "unknown")
  endif()
endif()

###############################################################################

# Generate the "config.h" file.
#
set(ENABLE_TRANS_ASSERT ON CACHE BOOL
  "Use assert() in clang_delta transformations.")

check_include_file("dlfcn.h"		HAVE_DLFCN_H)
check_include_file("inttypes.h"		HAVE_INTTYPES_H)
check_include_file("memory.h"		HAVE_MEMORY_H)
check_include_file("stdint.h"		HAVE_STDINT_H)
check_include_file("stdlib.h"		HAVE_STDLIB_H)
check_include_file("strings.h"		HAVE_STRINGS_H)
check_include_file("string.h"		HAVE_STRING_H)
check_include_file("sys/stat.h"		HAVE_SYS_STAT_H)
check_include_file("sys/types.h"	HAVE_SYS_TYPES_H)
check_include_file("unistd.h"		HAVE_UNISTD_H)

set(cvise_PACKAGE             "cvise")
set(cvise_PACKAGE_BUGREPORT   "https://github.com/marxin/cvise/issues")
set(cvise_PACKAGE_NAME        "cvise")
set(cvise_PACKAGE_STRING      "cvise 2.7.0")
set(cvise_PACKAGE_TARNAME     "cvise")
set(cvise_PACKAGE_URL         "https://github.com/marxin/cvise/")
set(cvise_PACKAGE_VERSION     "2.7.0")
set(cvise_VERSION             "2.7.0")
set(cvise_LLVM_VERSION        "${LLVM_PACKAGE_VERSION}")

configure_file("cmake_config.h.in" "${PROJECT_BINARY_DIR}/config.h")
add_definitions("-DHAVE_CONFIG_H")

###############################################################################

# Use option `-fvisibility-inlines-hidden` if the C++ compiler supports it.
# See LLVM file `share/llvm/cmake/HandleLLVMOptions.cmake`.
#
check_cxx_compiler_flag(
  "-fvisibility-inlines-hidden"
  SUPPORTS_FVISIBILITY_INLINES_HIDDEN_FLAG
)

check_cxx_compiler_flag(
  "-Wno-error=mismatched-new-delete"
  SUPPORTS_WMISMATCHED_NEW_DELETE
)

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
    OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  # XXX figure out how to get "-std=c++17 -fno-rtti" from LLVM.  That's how we
  # get those options in the Automake path...
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Werror -Wno-error=maybe-uninitialized")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -fno-rtti -fno-strict-aliasing -Wall -Wextra -Wno-unused-parameter -Werror -Wno-error=maybe-uninitialized")
  if(SUPPORTS_FVISIBILITY_INLINES_HIDDEN_FLAG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
  endif()
  if(SUPPORTS_WMISMATCHED_NEW_DELETE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=mismatched-new-delete")
  endif()

  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELEASE} -O3 -g")
endif()

###############################################################################

# Enable tests
enable_testing()
add_test(NAME all COMMAND ${PYTHON_EXECUTABLE} -m pytest)

###############################################################################

# Needs to be sourced after we have a compiler tested
include(GNUInstallDirs)

add_subdirectory(clang_delta)
add_subdirectory(clex)
add_subdirectory(cvise)
add_subdirectory(delta)

# Copy top-level cvise script
configure_file(
  "${PROJECT_SOURCE_DIR}/cvise.py"
  "${PROJECT_BINARY_DIR}/cvise.py"
  @ONLY
)

configure_file(
  "${PROJECT_SOURCE_DIR}/cvise-delta.py"
  "${PROJECT_BINARY_DIR}/cvise-delta.py"
  @ONLY
)

configure_file(
  "${PROJECT_SOURCE_DIR}/tests/test_cvise.py"
  "${PROJECT_BINARY_DIR}/tests/test_cvise.py"
  COPYONLY
)

configure_file(
  "${PROJECT_SOURCE_DIR}/tests/sources/blocksort-part.c"
  "${PROJECT_BINARY_DIR}/tests/sources/blocksort-part.c"
  COPYONLY
)

configure_file(
  "${PROJECT_SOURCE_DIR}/setup.cfg"
  "${PROJECT_BINARY_DIR}/setup.cfg"
  COPYONLY
)

install(PROGRAMS "${PROJECT_BINARY_DIR}/cvise.py"
  DESTINATION "${CMAKE_INSTALL_BINDIR}"
  RENAME "cvise"
)

install(PROGRAMS "${PROJECT_BINARY_DIR}/cvise-delta.py"
  DESTINATION "${CMAKE_INSTALL_BINDIR}"
  RENAME "cvise-delta"
)

###############################################################################

## End of file.

=== clang_delta/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019 The University of Utah
## All rights reserved.
##
## This file is distributed under the University of Illinois Open Source
## License.  See the file COPYING for details.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)
project(clang_delta)

###############################################################################

# find_package(LLVM) is done by the topmost "CMakeLists.txt" file.
# find_package(Clang) is done by the topmost "CMakeLists.txt" file.

# Generate file "git_version.cpp".
#
configure_file("git_version.cpp.in" "git_version.cpp" @ONLY)

function(configure_one_file path)
  configure_file(
    "${clang_delta_SOURCE_DIR}/${path}"
    "${clang_delta_BINARY_DIR}/${path}"
    COPYONLY
  )
endfunction(configure_one_file)

set(SOURCE_FILES
  "/tests/test_clang_delta.py"
  "/tests/aggregate-to-scalar/cast.c"
  "/tests/aggregate-to-scalar/cast.output"
  "/tests/aggregate-to-scalar/test1.c"
  "/tests/aggregate-to-scalar/test1.output"
  "/tests/aggregate-to-scalar/test2.c"
  "/tests/aggregate-to-scalar/test2.output"
  "/tests/aggregate-to-scalar/test3.c"
  "/tests/aggregate-to-scalar/test3.output"
  "/tests/aggregate-to-scalar/test4.c"
  "/tests/aggregate-to-scalar/test4.output"
  "/tests/aggregate-to-scalar/test5.cc"
  "/tests/aggregate-to-scalar/test5.output"
  "/tests/aggregate-to-scalar/test6.cc"
  "/tests/aggregate-to-scalar/test6.output"
  "/tests/callexpr-to-value/macro1.c"
  "/tests/callexpr-to-value/macro1.output"
  "/tests/callexpr-to-value/macro2.c"
  "/tests/callexpr-to-value/macro2.output"
  "/tests/callexpr-to-value/test1.c"
  "/tests/callexpr-to-value/test1.output"
  "/tests/callexpr-to-value/test2.c"
  "/tests/callexpr-to-value/test2.output"
  "/tests/class-to-struct/class-to-struct1.C"
  "/tests/class-to-struct/class-to-struct1.output"
  "/tests/class-to-struct/class-to-struct-forward.C"
  "/tests/class-template-to-class/test1.cc"
  "/tests/class-template-to-class/test1.output"
  "/tests/copy-propagation/copy1.cpp"
  "/tests/copy-propagation/copy1.output"
  "/tests/copy-propagation/copy2.cpp"
  "/tests/copy-propagation/copy2.output"
  "/tests/empty-struct-to-int/empty-struct.cpp"
  "/tests/empty-struct-to-int/empty-struct.output"
  "/tests/empty-struct-to-int/empty-struct2.cpp"
  "/tests/empty-struct-to-int/empty-struct2.output"
  "/tests/empty-struct-to-int/empty-struct3.cpp"
  "/tests/empty-struct-to-int/empty-struct3.output"
  "/tests/empty-struct-to-int/empty-struct4.cpp"
  "/tests/empty-struct-to-int/empty-struct4.output"
  "/tests/empty-struct-to-int/empty-struct5.cpp"
  "/tests/empty-struct-to-int/empty-struct5.output"
  "/tests/empty-struct-to-int/empty-struct6.c"
  "/tests/empty-struct-to-int/empty-struct6.output"
  "/tests/empty-struct-to-int/empty-struct7.c"
  "/tests/empty-struct-to-int/empty-struct7.output"
  "/tests/empty-struct-to-int/struct_int.c"
  "/tests/empty-struct-to-int/struct_int.output"
  "/tests/empty-struct-to-int/test1.cc"
  "/tests/empty-struct-to-int/test1.output"
  "/tests/empty-struct-to-int/test2.cc"
  "/tests/empty-struct-to-int/test2.output"
  "/tests/empty-struct-to-int/test3.c"
  "/tests/empty-struct-to-int/test3.output"
  "/tests/instantiate-template-param/default_param.cc"
  "/tests/instantiate-template-param/default_param.output"
  "/tests/instantiate-template-param/test1.cc"
  "/tests/instantiate-template-param/test1.output"
  "/tests/instantiate-template-param/test2.cc"
  "/tests/instantiate-template-param/test2.output"
  "/tests/instantiate-template-param/test3.cc"
  "/tests/instantiate-template-param/test4.cc"
  "/tests/instantiate-template-param/test4.output"
  "/tests/instantiate-template-param/test5.cc"
  "/tests/instantiate-template-param/test5.output"
  "/tests/instantiate-template-param/test6.cc"
  "/tests/instantiate-template-param/test6.output"
  "/tests/instantiate-template-param/test7.cc"
  "/tests/instantiate-template-param/test7.output"
  "/tests/instantiate-template-param/test8a.cc"
  "/tests/instantiate-template-param/test8a.output"
  "/tests/instantiate-template-param/test8b.cc"
  "/tests/instantiate-template-param/test8b.output"
  "/tests/instantiate-template-param/test8c.cc"
  "/tests/instantiate-template-param/test8c.output"
  "/tests/local-to-global/macro.c"
  "/tests/local-to-global/macro.output"
  "/tests/local-to-global/unnamed_1.c"
  "/tests/local-to-global/unnamed_1.output"
  "/tests/local-to-global/unnamed_2.c"
  "/tests/local-to-global/unnamed_2.output"
  "/tests/local-to-global/unnamed_3.c"
  "/tests/local-to-global/unnamed_3.output"
  "/tests/param-to-global/macro.c"
  "/tests/param-to-global/macro.output"
  "/tests/reduce-array-dim/non-type-temp-arg.cpp"
  "/tests/reduce-array-dim/non-type-temp-arg.output"
  "/tests/reduce-pointer-level/scalar-init-expr.cpp"
  "/tests/reduce-pointer-level/scalar-init-expr.output"
  "/tests/merge-base-class/test1.cc"
  "/tests/merge-base-class/test1.output"
  "/tests/merge-base-class/test2.cc"
  "/tests/merge-base-class/test2.output"
  "/tests/merge-base-class/test3.cc"
  "/tests/merge-base-class/test3.output"
  "/tests/remove-base-class/test1.cc"
  "/tests/remove-base-class/test1.output"
  "/tests/remove-base-class/test2.cc"
  "/tests/remove-base-class/test2.output"
  "/tests/remove-base-class/test3.cc"
  "/tests/remove-base-class/test3.output"
  "/tests/remove-base-class/test4.cc"
  "/tests/remove-base-class/test4.output"
  "/tests/move-definition-to-declaration/func1.cc"
  "/tests/move-definition-to-declaration/func1.output"
  "/tests/move-definition-to-declaration/func2.cc"
  "/tests/move-definition-to-declaration/func2.output"
  "/tests/move-definition-to-declaration/func3.cc"
  "/tests/move-definition-to-declaration/func3.output"
  "/tests/move-definition-to-declaration/func4.cc"
  "/tests/move-definition-to-declaration/func4.output"
  "/tests/move-definition-to-declaration/func5.cc"
  "/tests/move-definition-to-declaration/func5.output"
  "/tests/move-definition-to-declaration/func6.cc"
  "/tests/move-definition-to-declaration/struct1.cc"
  "/tests/move-definition-to-declaration/struct1.output"
  "/tests/move-definition-to-declaration/struct2.cc"
  "/tests/move-definition-to-declaration/struct2.output"
  "/tests/move-definition-to-declaration/var1.cc"
  "/tests/move-definition-to-declaration/var1.output"
  "/tests/remove-namespace/macro.cpp"
  "/tests/remove-namespace/macro.output"
  "/tests/remove-namespace/macro.output2"
  "/tests/remove-namespace/macro.output3"
  "/tests/remove-namespace/macro.output4"
  "/tests/remove-namespace/macro.output5"
  "/tests/remove-namespace/namespace.cpp"
  "/tests/remove-namespace/namespace.output"
  "/tests/remove-namespace/namespace.output2"
  "/tests/remove-namespace/namespace.output3"
  "/tests/remove-namespace/namespace2.cpp"
  "/tests/remove-namespace/namespace2.output"
  "/tests/remove-namespace/namespace2.output2"
  "/tests/remove-namespace/namespace3.cpp"
  "/tests/remove-namespace/namespace3.output"
  "/tests/remove-namespace/namespace3.output2"
  "/tests/remove-namespace/namespace3.output3"
  "/tests/remove-namespace/namespace4.cpp"
  "/tests/remove-namespace/namespace4.output"
  "/tests/remove-namespace/namespace5.cpp"
  "/tests/remove-namespace/namespace5.output"
  "/tests/remove-namespace/namespace5.output2"
  "/tests/remove-namespace/namespace5.output3"
  "/tests/remove-namespace/namespace5.output4"
  "/tests/remove-namespace/namespace6.cpp"
  "/tests/remove-namespace/namespace6.output"
  "/tests/remove-namespace/namespace6.output2"
  "/tests/remove-namespace/namespace7.cpp"
  "/tests/remove-namespace/namespace7.output"
  "/tests/remove-namespace/namespace7.output2"
  "/tests/remove-namespace/namespace7.output3"
  "/tests/remove-namespace/namespace8.cpp"
  "/tests/remove-namespace/namespace8.output"
  "/tests/remove-namespace/namespace8.output2"
  "/tests/remove-namespace/namespace9.cpp"
  "/tests/remove-namespace/namespace9.output"
  "/tests/remove-namespace/namespace10.cpp"
  "/tests/remove-namespace/namespace10.output"
  "/tests/remove-namespace/namespace10.output2"
  "/tests/remove-namespace/namespace11.cpp"
  "/tests/remove-namespace/namespace11.output"
  "/tests/remove-namespace/namespace11.output2"
  "/tests/remove-namespace/namespace12.cpp"
  "/tests/remove-namespace/namespace12.output"
  "/tests/remove-namespace/namespace12.output2"
  "/tests/remove-namespace/namespace12.output3"
  "/tests/remove-namespace/namespace13.cpp"
  "/tests/remove-namespace/namespace13.output"
  "/tests/remove-namespace/namespace13.output2"
  "/tests/remove-namespace/namespace14.cpp"
  "/tests/remove-namespace/namespace14.output"
  "/tests/remove-namespace/namespace15.cpp"
  "/tests/remove-namespace/namespace15.output"
  "/tests/remove-namespace/namespace15.output2"
  "/tests/remove-namespace/namespace15.output3"
  "/tests/remove-enum-member-value/builtin_macro.c"
  "/tests/remove-enum-member-value/builtin_macro.output"
  "/tests/remove-unused-enum-member/range.c"
  "/tests/remove-unused-enum-member/range.output"
  "/tests/remove-nested-function/remove_nested_func1.cc"
  "/tests/remove-nested-function/remove_nested_func1.output"
  "/tests/remove-try-catch/try-catch-1.cpp"
  "/tests/remove-try-catch/try-catch-1.output"
  "/tests/remove-try-catch/try-catch-2.cpp"
  "/tests/remove-try-catch/try-catch-2.output"
  "/tests/remove-unused-field/designated1.c"
  "/tests/remove-unused-field/designated1.output"
  "/tests/remove-unused-field/designated2.c"
  "/tests/remove-unused-field/designated2.output"
  "/tests/remove-unused-field/designated3.c"
  "/tests/remove-unused-field/designated3.output"
  "/tests/remove-unused-field/designated4.c"
  "/tests/remove-unused-field/designated4.output"
  "/tests/remove-unused-field/designated5.c"
  "/tests/remove-unused-field/designated5.output"
  "/tests/remove-unused-field/unused_field1.c"
  "/tests/remove-unused-field/unused_field1.output"
  "/tests/remove-unused-field/unused_field2.c"
  "/tests/remove-unused-field/unused_field2.output"
  "/tests/remove-unused-field/unused_field3.cpp"
  "/tests/remove-unused-field/unused_field3.output"
  "/tests/remove-unused-function/class.cc"
  "/tests/remove-unused-function/class.output"
  "/tests/remove-unused-function/const.cc"
  "/tests/remove-unused-function/const.output"
  "/tests/remove-unused-function/const.output2"
  "/tests/remove-unused-function/default.cc"
  "/tests/remove-unused-function/default.output"
  "/tests/remove-unused-function/default.output2"
  "/tests/remove-unused-function/delete.cc"
  "/tests/remove-unused-function/delete.output"
  "/tests/remove-unused-function/delete2.cc"
  "/tests/remove-unused-function/delete2.output"
  "/tests/remove-unused-function/delete2.output2"
  "/tests/remove-unused-function/delete2.output3"
  "/tests/remove-unused-function/delete2.output4"
  "/tests/remove-unused-function/inline_ns.cc"
  "/tests/remove-unused-function/inline_ns.output"
  "/tests/remove-unused-function/macro1.cc"
  "/tests/remove-unused-function/macro1.output"
  "/tests/remove-unused-function/macro2.cc"
  "/tests/remove-unused-function/macro2.output"
  "/tests/remove-unused-function/macro3.cc"
  "/tests/remove-unused-function/macro3.output"
  "/tests/remove-unused-function/template1.cc"
  "/tests/remove-unused-function/template1.output"
  "/tests/remove-unused-function/template2.cc"
  "/tests/remove-unused-function/template2.output"
  "/tests/remove-unused-function/unused-funcs.cc"
  "/tests/remove-unused-function/unused-funcs.output"
  "/tests/remove-unused-var/struct1.c"
  "/tests/remove-unused-var/struct1.output"
  "/tests/remove-unused-var/struct2.c"
  "/tests/remove-unused-var/struct2.output"
  "/tests/remove-unused-var/unused_var.cpp"
  "/tests/remove-unused-var/unused_var.output"
  "/tests/rename-class/base_specifier.cpp"
  "/tests/rename-class/base_specifier.output"
  "/tests/rename-class/bool.cc"
  "/tests/rename-class/bool.output"

=== cvise/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2018, 2019 The University of Utah
## All rights reserved.
##
## This file is distributed under the University of Illinois Open Source
## License.  See the file COPYING for details.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)

project(cvise_python)

###############################################################################

# find_package(LLVM) is done by the topmost "CMakeLists.txt" file.

###############################################################################

# Check for the run-time prerequisites of C-Vise.  We only warn the user when
# these are not found at configure time.  Let the user install the dependencies
# later.
#
if(CLANG_FORMAT)
  find_program(CLANG_FORMAT_PATH
    "${CLANG_FORMAT}"
    PATHS "${LLVM_TOOLS_BINARY_DIR}"
  )
else()
  find_program(CLANG_FORMAT_PATH
    "clang-format${CMAKE_EXECUTABLE_SUFFIX}"
    PATHS "${LLVM_TOOLS_BINARY_DIR}"
    )
endif()

if(NOT CLANG_FORMAT_PATH)
  message(STATUS "`clang-format${CMAKE_EXECUTABLE_SUFFIX}' was not found")
  message("You must install `clang-format' before running C-Vise.")
  set(CLANG_FORMAT_PATH "clang-format")
else()
  message(STATUS "Using clang-format in ${CLANG_FORMAT_PATH}")
endif()

###############################################################################

# Generate file "cvise.py".
#
configure_file("${cvise_python_SOURCE_DIR}/cvise.py"
  "${cvise_python_BINARY_DIR}/cvise.py"
)

###############################################################################

# Copy the Python modules into the build tree so that we can run C-Vise there.
#
function(configure_one_file path)
  configure_file(
    "${cvise_python_SOURCE_DIR}/${path}"
    "${cvise_python_BINARY_DIR}/${path}"
    COPYONLY
  )
endfunction(configure_one_file)

set(SOURCE_FILES
  "__init__.py"
  "pass_groups/all.json"
  "pass_groups/opencl-120.json"
  "pass_groups/delta.json"
  "pass_groups/binary.json"
  "passes/__init__.py"
  "passes/abstract.py"
  "passes/balanced.py"
  "passes/blank.py"
  "passes/clang.py"
  "passes/clangbinarysearch.py"
  "passes/clex.py"
  "passes/comments.py"
  "passes/gcdabinary.py"
  "passes/ifs.py"
  "passes/includeincludes.py"
  "passes/includes.py"
  "passes/indent.py"
  "passes/ints.py"
  "passes/line_markers.py"
  "passes/lines.py"
  "passes/peep.py"
  "passes/special.py"
  "passes/ternary.py"
  "passes/unifdef.py"
  "tests/__init__.py"
  "tests/testabstract.py"
  "tests/test_balanced.py"
  "tests/test_comments.py"
  "tests/test_ifs.py"
  "tests/test_ints.py"
  "tests/test_line_markers.py"
  "tests/test_nestedmatcher.py"
  "tests/test_peep.py"
  "tests/test_special.py"
  "tests/test_ternary.py"
  "utils/__init__.py"
  "utils/error.py"
  "utils/misc.py"
  "utils/nestedmatcher.py"
  "utils/readkey.py"
  "utils/statistics.py"
  "utils/testing.py"
)

foreach(file IN LISTS SOURCE_FILES)
  configure_one_file(${file})
endforeach()

###############################################################################

install(DIRECTORY "${cvise_python_BINARY_DIR}/"
  DESTINATION "${CMAKE_INSTALL_DATADIR}/${cvise_PACKAGE}"
  FILES_MATCHING
  PATTERN "*.py"
  PATTERN "*.json"
  PATTERN "__pycache__" EXCLUDE
  PATTERN "CMakeFiles" EXCLUDE
)

###############################################################################

## End of file.

=== delta/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2016 The University of Utah
## All rights reserved.
##
## This file is distributed under the University of Illinois Open Source
## License.  See the file COPYING for details.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)

# find_package(FLEX) is done by the topmost "CMakeLists.txt" file.

###############################################################################

project(topformflat)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})
include_directories(${CMAKE_BINARY_DIR})

FLEX_TARGET(topformflat_scanner
  topformflat.l
  ${PROJECT_BINARY_DIR}/topformflat.c
  )

add_executable(topformflat
  ${FLEX_topformflat_scanner_OUTPUTS}
  )

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
    OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
set_source_files_properties(topformflat.c PROPERTIES COMPILE_FLAGS "-Wno-unused-function -Wno-unused-parameter")
endif()
if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
set_source_files_properties(topformflat.c PROPERTIES COMPILE_FLAGS -DYY_NO_UNISTD_H)
endif()

###############################################################################

install(TARGETS topformflat
  DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/${cvise_PACKAGE}/"
  )

###############################################################################

## End of file.

=== debian/changelog ===
cvise (2.7.0-2) unstable; urgency=medium

  * Don't call dh_dwz on mipsel (runs out of memory).

 -- Matthias Klose <doko@debian.org>  Sat, 31 Dec 2022 10:52:35 +0100

cvise (2.7.0-1) unstable; urgency=medium

  * New upstream version.
  * Drop the excessive llvm build dependencies.

 -- Matthias Klose <doko@debian.org>  Mon, 26 Dec 2022 11:39:03 +0100

=== debian/control ===
Source: cvise
Section: misc
Priority: optional
Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
Uploaders: Matthias Klose <doko@debian.org>
Build-Depends: debhelper-compat (= 12),
  dh-python,
  chrpath,
  cmake,
  flex,
  python3,
  python3-chardet,
  python3-pebble,
  python3-psutil,
  python3-pytest <!nocheck>,
  python3-pytest-flake8 <!nocheck>,
  llvm-15-dev, libclang-15-dev, clang-15, clang-format-15,
#  clang-tools-15, clang-tidy-15, clangd-15,
  unifdef,
Standards-Version: 4.6.1
Homepage: https://github.com/marxin/cvise

Package: cvise
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
  clang-format-15,
  python3,
  python3-chardet,
  python3-pebble,
  python3-psutil,
  unifdef,
Recommends: colordiff
Description: super-parallel Python port of the C-Reduce project
 C-Vise is a tool that takes a large C, C++ or OpenCL program that has
 a property of interest (such as triggering a compiler bug) and
 automatically produces a much smaller C/C++ or OpenCL program that
 has the same property. It is intended for use by people who discover
 and report bugs in compilers and other tools that process C/C++ or
 OpenCL code.
 .
 NOTE: C-Vise happens to do a pretty good job reducing the size of
 programs in languages other than C/C++, such as JavaScript and
 Rust. If you need to reduce programs in some other language, please
 give it a try.

## cvise 2.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 ###############################################################################
 
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.3)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
@@ -88,7 +88,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "d9e4a505")
+set(GIT_HASH "7aaa2515")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)
@@ -122,11 +122,11 @@
 set(cvise_PACKAGE             "cvise")
 set(cvise_PACKAGE_BUGREPORT   "https://github.com/marxin/cvise/issues")
 set(cvise_PACKAGE_NAME        "cvise")
-set(cvise_PACKAGE_STRING      "cvise 2.7.0")
+set(cvise_PACKAGE_STRING      "cvise 2.8.0")
 set(cvise_PACKAGE_TARNAME     "cvise")
 set(cvise_PACKAGE_URL         "https://github.com/marxin/cvise/")
-set(cvise_PACKAGE_VERSION     "2.7.0")
-set(cvise_VERSION             "2.7.0")
+set(cvise_PACKAGE_VERSION     "2.8.0")
+set(cvise_VERSION             "2.8.0")
 set(cvise_LLVM_VERSION        "${LLVM_PACKAGE_VERSION}")
 
 configure_file("cmake_config.h.in" "${PROJECT_BINARY_DIR}/config.h")
@@ -143,21 +143,31 @@
 )
 
 check_cxx_compiler_flag(
-  "-Wno-error=mismatched-new-delete"
+  "-Wmismatched-new-delete"
   SUPPORTS_WMISMATCHED_NEW_DELETE
+)
+
+check_cxx_compiler_flag(
+  "-Wmaybe-uninitialized"
+  SUPPORTS_MAYBE_UNINITIALIZED
 )
 
 if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
     OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
   # XXX figure out how to get "-std=c++17 -fno-rtti" from LLVM.  That's how we
   # get those options in the Automake path...
-  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Werror -Wno-error=maybe-uninitialized")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -fno-rtti -fno-strict-aliasing -Wall -Wextra -Wno-unused-parameter -Werror -Wno-error=maybe-uninitialized")
+  set(COMMON_FLAGS "-Wall -Wextra -Werror -pedantic -Wno-unused-parameter")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${COMMON_FLAGS}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${COMMON_FLAGS} -std=c++17 -fno-rtti -fno-strict-aliasing")
   if(SUPPORTS_FVISIBILITY_INLINES_HIDDEN_FLAG)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
   endif()
   if(SUPPORTS_WMISMATCHED_NEW_DELETE)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=mismatched-new-delete")
+  endif()
+  if(SUPPORTS_MAYBE_UNINITIALIZED)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=maybe-uninitialized")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=maybe-uninitialized")
   endif()
 
   set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")

=== clang_delta/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 ###############################################################################
 
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.3)
 project(clang_delta)
 
 ###############################################################################
@@ -259,6 +259,7 @@
   "/tests/remove-unused-function/template2.output"
   "/tests/remove-unused-function/unused-funcs.cc"
   "/tests/remove-unused-function/unused-funcs.output"
+  "/tests/remove-unused-function/cyclic-namespace-using.cc"
   "/tests/remove-unused-var/struct1.c"
   "/tests/remove-unused-var/struct1.output"
   "/tests/remove-unused-var/struct2.c"
@@ -268,4 +269,3 @@
   "/tests/rename-class/base_specifier.cpp"
   "/tests/rename-class/base_specifier.output"
   "/tests/rename-class/bool.cc"
-  "/tests/rename-class/bool.output"

=== clex/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2012, 2013, 2014, 2015, 2016 The University of Utah
## All rights reserved.
##
## This file is distributed under the University of Illinois Open Source
## License.  See the file COPYING for details.

###############################################################################

cmake_minimum_required(VERSION 3.3)

# find_package(FLEX) is done by the topmost "CMakeLists.txt" file.

###############################################################################

project(clex)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})
include_directories(${CMAKE_BINARY_DIR})

FLEX_TARGET(clex_scanner
  clex.l
  ${PROJECT_BINARY_DIR}/clex.c
  )

add_executable(clex
  ${FLEX_clex_scanner_OUTPUTS}
  defs.h
  driver.c
  )

###############################################################################

project(strlex)
include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})
include_directories(${CMAKE_BINARY_DIR})

FLEX_TARGET(strlex_scanner
  strlex.l
  ${PROJECT_BINARY_DIR}/strlex.c
  )

add_executable(strlex
  ${FLEX_strlex_scanner_OUTPUTS}
  defs.h
  driver.c
  )

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
    OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
set_source_files_properties(clex.c PROPERTIES COMPILE_FLAGS -Wno-unused-function)
set_source_files_properties(strlex.c PROPERTIES COMPILE_FLAGS -Wno-unused-function)
endif()
if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
set_source_files_properties(clex.c PROPERTIES COMPILE_FLAGS -DYY_NO_UNISTD_H)
set_source_files_properties(strlex.c PROPERTIES COMPILE_FLAGS -DYY_NO_UNISTD_H)
endif()

###############################################################################

install(TARGETS clex strlex
  DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/${cvise_PACKAGE}/"
  )

###############################################################################

## End of file.

=== cvise/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 ###############################################################################
 
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.3)
 
 project(cvise_python)

=== delta/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 ###############################################################################
 
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.3)
 
 # find_package(FLEX) is done by the topmost "CMakeLists.txt" file.

=== debian/changelog ===
cvise (2.8.0-2) unstable; urgency=medium

  * Build using LLVM 16.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 24 Aug 2023 19:10:09 +0200

cvise (2.8.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Tue, 06 Jun 2023 17:23:25 +0200

=== debian/control ===
--- 
+++ 
@@ -14,16 +14,16 @@
   python3-psutil,
   python3-pytest <!nocheck>,
   python3-pytest-flake8 <!nocheck>,
-  llvm-15-dev, libclang-15-dev, clang-15, clang-format-15,
-#  clang-tools-15, clang-tidy-15, clangd-15,
+  llvm-16-dev, libclang-16-dev, clang-16, clang-format-16,
+#  clang-tools-16, clang-tidy-16, clangd-16,
   unifdef,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/marxin/cvise
 
 Package: cvise
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
-  clang-format-15,
+  clang-format-16,
   python3,
   python3-chardet,
   python3-pebble,

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

CLANG_V=16
V=$(shell dpkg-parsechangelog -S Version | sed 's/-.*$$//')

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_PREFIX_PATH=/usr/lib/llvm-$(CLANG_V) \
		-DCLANG_FORMAT=clang-format-$(CLANG_V) \
		-DCMAKE_INSTALL_LIBEXECDIR=lib

override_dh_auto_build:
	dh_auto_build

override_dh_auto_install:
	dh_auto_install

ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
	if which help2man >/dev/null 2>&1; then \
	  DESTDIR=$(CURDIR)/debian/cvise help2man --name='super-parallel Python port of the C-Reduce project' \
	    --version-string=$(V) \
	    --no-info \
	    debian/cvise/usr/bin/cvise > debian/cvise.1; \
	fi
endif
	mkdir -p debian/cvise/usr/share/man/man1
	cp debian/cvise.1 debian/cvise/usr/share/man/man1/cvise.1

override_dh_dwz:
ifeq (,$(filter $(DEB_HOST_ARCH), mipsel))
	dh_dwz
endif

override_dh_shlibdeps:
	chrpath -d debian/cvise/usr/lib/cvise/clang_delta
	dh_shlibdeps

override_dh_auto_clean:
	find -name __pycache__ | xargs -r rm -rf
	dh_auto_clean

## cvise 2.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 ###############################################################################
 
-cmake_minimum_required(VERSION 3.3)
+cmake_minimum_required(VERSION 3.14)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
@@ -22,7 +22,7 @@
   message(FATAL_ERROR "CMAKE_SOURCE_DIR should be different from PROJECT_BINARY_DIR")
 endif()
 
-###############################################################################
+##############################################################################
 
 # Locate LLVM and check its version.  Do this here because we need the LLVM
 # package definitions in the "CMakeLists.txt" files for multiple subdirs.
@@ -41,10 +41,10 @@
 
 # Locate Python and check its version.
 #
-find_package(PythonInterp 3.6 REQUIRED)
+find_package(Python3)
 
 # Locate pytest
-execute_process(COMMAND ${PYTHON_EXECUTABLE} -m pytest --version
+execute_process(COMMAND ${Python3_EXECUTABLE} -m pytest --version
   OUTPUT_VARIABLE PYTEST_output
   ERROR_VARIABLE  PYTEST_error
   RESULT_VARIABLE PYTEST_result)
@@ -53,7 +53,7 @@
 endif()
 
 # Locate Pebble
-execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import pebble"
+execute_process(COMMAND ${Python3_EXECUTABLE} -c "import pebble"
   OUTPUT_VARIABLE PEBBLE_output
   ERROR_VARIABLE  PEBBLE_error
   RESULT_VARIABLE PEBBLE_result)
@@ -62,7 +62,7 @@
 endif()
 
 # Locate psutil
-execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import psutil"
+execute_process(COMMAND ${Python3_EXECUTABLE} -c "import psutil"
   OUTPUT_VARIABLE PSUTIL_output
   ERROR_VARIABLE  PSUTIL_error
   RESULT_VARIABLE PSUTIL_result)
@@ -88,7 +88,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "7aaa2515")
+set(GIT_HASH "cc76e98d")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)
@@ -122,11 +122,11 @@
 set(cvise_PACKAGE             "cvise")
 set(cvise_PACKAGE_BUGREPORT   "https://github.com/marxin/cvise/issues")
 set(cvise_PACKAGE_NAME        "cvise")
-set(cvise_PACKAGE_STRING      "cvise 2.8.0")
+set(cvise_PACKAGE_STRING      "cvise 2.9.0")
 set(cvise_PACKAGE_TARNAME     "cvise")
 set(cvise_PACKAGE_URL         "https://github.com/marxin/cvise/")
-set(cvise_PACKAGE_VERSION     "2.8.0")
-set(cvise_VERSION             "2.8.0")
+set(cvise_PACKAGE_VERSION     "2.9.0")
+set(cvise_VERSION             "2.9.0")
 set(cvise_LLVM_VERSION        "${LLVM_PACKAGE_VERSION}")
 
 configure_file("cmake_config.h.in" "${PROJECT_BINARY_DIR}/config.h")
@@ -151,6 +151,17 @@
   "-Wmaybe-uninitialized"
   SUPPORTS_MAYBE_UNINITIALIZED
 )
+
+check_cxx_compiler_flag(
+  "-Wclass-memaccess"
+  SUPPORTS_CLASS_MEMACCESS
+)
+
+check_cxx_compiler_flag(
+  "-Wnon-template-friend"
+  SUPPORTS_NON_TEMPLATE_FRIEND
+)
+
 
 if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
     OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
@@ -169,6 +180,14 @@
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=maybe-uninitialized")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=maybe-uninitialized")
   endif()
+  if(SUPPORTS_CLASS_MEMACCESS)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=class-memaccess")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=class-memaccess")
+  endif()
+  if(SUPPORTS_NON_TEMPLATE_FRIEND)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=non-template-friend")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=non-template-friend")
+  endif()
 
   set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
   set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELEASE} -O3 -g")
@@ -178,7 +197,7 @@
 
 # Enable tests
 enable_testing()
-add_test(NAME all COMMAND ${PYTHON_EXECUTABLE} -m pytest)
+add_test(NAME all COMMAND ${Python3_EXECUTABLE} -m pytest)
 
 ###############################################################################

=== clex/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 ###############################################################################
 
-cmake_minimum_required(VERSION 3.3)
+cmake_minimum_required(VERSION 3.14)
 
 # find_package(FLEX) is done by the topmost "CMakeLists.txt" file.

=== delta/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 ###############################################################################
 
-cmake_minimum_required(VERSION 3.3)
+cmake_minimum_required(VERSION 3.14)
 
 # find_package(FLEX) is done by the topmost "CMakeLists.txt" file.

=== debian/changelog ===
cvise (2.9.0-2) unstable; urgency=medium

  * Build using LLVM 17.0.6.

 -- Matthias Klose <doko@debian.org>  Sun, 10 Dec 2023 19:29:46 +0100

cvise (2.9.0-1) unstable; urgency=medium

  * New upstream version.
  * Build using LLVM 17.

 -- Matthias Klose <doko@debian.org>  Thu, 16 Nov 2023 14:08:12 +0100

=== debian/control ===
--- 
+++ 
@@ -14,8 +14,8 @@
   python3-psutil,
   python3-pytest <!nocheck>,
   python3-pytest-flake8 <!nocheck>,
-  llvm-16-dev, libclang-16-dev, clang-16, clang-format-16,
-#  clang-tools-16, clang-tidy-16, clangd-16,
+  llvm-17-dev, libclang-17-dev, clang-17 (>= 1:17.0.6), clang-format-17,
+#  clang-tools-17, clang-tidy-17, clangd-17,
   unifdef,
 Standards-Version: 4.6.2
 Homepage: https://github.com/marxin/cvise
@@ -23,7 +23,7 @@
 Package: cvise
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
-  clang-format-16,
+  clang-format-17,
   python3,
   python3-chardet,
   python3-pebble,

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-CLANG_V=16
+CLANG_V=17
 V=$(shell dpkg-parsechangelog -S Version | sed 's/-.*$$//')
 
 %:

## cvise 2.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -88,7 +88,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "cc76e98d")
+set(GIT_HASH "c8606497")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)
@@ -122,11 +122,11 @@
 set(cvise_PACKAGE             "cvise")
 set(cvise_PACKAGE_BUGREPORT   "https://github.com/marxin/cvise/issues")
 set(cvise_PACKAGE_NAME        "cvise")
-set(cvise_PACKAGE_STRING      "cvise 2.9.0")
+set(cvise_PACKAGE_STRING      "cvise 2.10.0")
 set(cvise_PACKAGE_TARNAME     "cvise")
 set(cvise_PACKAGE_URL         "https://github.com/marxin/cvise/")
-set(cvise_PACKAGE_VERSION     "2.9.0")
-set(cvise_VERSION             "2.9.0")
+set(cvise_PACKAGE_VERSION     "2.10.0")
+set(cvise_VERSION             "2.10.0")
 set(cvise_LLVM_VERSION        "${LLVM_PACKAGE_VERSION}")
 
 configure_file("cmake_config.h.in" "${PROJECT_BINARY_DIR}/config.h")
@@ -162,9 +162,13 @@
   SUPPORTS_NON_TEMPLATE_FRIEND
 )
 
+check_cxx_compiler_flag(
+  "-Wdeprecated-declarations"
+  SUPPORTS_DEPRECATED_DECLARATIONS
+)
 
 if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
-    OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+    OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   # XXX figure out how to get "-std=c++17 -fno-rtti" from LLVM.  That's how we
   # get those options in the Automake path...
   set(COMMON_FLAGS "-Wall -Wextra -Werror -pedantic -Wno-unused-parameter")
@@ -188,6 +192,10 @@
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=non-template-friend")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=non-template-friend")
   endif()
+  iF(SUPPORTS_DEPRECATED_DECLARATIONS)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=deprecated-declarations")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=deprecated-declarations")
+  endif()
 
   set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
   set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELEASE} -O3 -g")

=== clang_delta/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 ###############################################################################
 
-cmake_minimum_required(VERSION 3.3)
+cmake_minimum_required(VERSION 3.14)
 project(clang_delta)
 
 ###############################################################################

=== cvise/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 ###############################################################################
 
-cmake_minimum_required(VERSION 3.3)
+cmake_minimum_required(VERSION 3.14)
 
 project(cvise_python)

=== debian/changelog ===
cvise (2.10.0-1ubuntu1) noble; urgency=medium

  * Drop dependency on python-pytest-flake8 (broken with modern flake8) which
    was already dropped upstream in cvise 2.10 and is now unused (LP: #2058917)

 -- Olivier Gayot <olivier.gayot@canonical.com>  Mon, 15 Apr 2024 14:21:31 +0100

cvise (2.10.0-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:42:33 +1100

cvise (2.10.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Wed, 13 Mar 2024 21:28:24 +0100

cvise (2.9.0-4) unstable; urgency=medium

  * Build using LLVM 18.

 -- Matthias Klose <doko@debian.org>  Tue, 12 Mar 2024 16:42:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: cvise
 Section: misc
 Priority: optional
-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper-compat (= 12),
   dh-python,
@@ -13,9 +14,8 @@
   python3-pebble,
   python3-psutil,
   python3-pytest <!nocheck>,
-  python3-pytest-flake8 <!nocheck>,
-  llvm-17-dev, libclang-17-dev, clang-17 (>= 1:17.0.6), clang-format-17,
-#  clang-tools-17, clang-tidy-17, clangd-17,
+  llvm-18-dev, libclang-18-dev, clang-18, clang-format-18,
+#  clang-tools-18, clang-tidy-18, clangd-18,
   unifdef,
 Standards-Version: 4.6.2
 Homepage: https://github.com/marxin/cvise
@@ -23,7 +23,7 @@
 Package: cvise
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
-  clang-format-17,
+  clang-format-18,
   python3,
   python3-chardet,
   python3-pebble,

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-CLANG_V=17
+CLANG_V=18
 V=$(shell dpkg-parsechangelog -S Version | sed 's/-.*$$//')
 
 %:
@@ -17,6 +17,9 @@
 
 override_dh_auto_build:
 	dh_auto_build
+
+override_dh_auto_test:
+	-dh_auto_test
 
 override_dh_auto_install:
 	dh_auto_install

## cvise 2.10.0+20240909

=== CMakeLists.txt ===
--- 
+++ 
@@ -88,7 +88,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "c8606497")
+set(GIT_HASH "$Format:%h$")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)
@@ -162,11 +162,6 @@
   SUPPORTS_NON_TEMPLATE_FRIEND
 )
 
-check_cxx_compiler_flag(
-  "-Wdeprecated-declarations"
-  SUPPORTS_DEPRECATED_DECLARATIONS
-)
-
 if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
     OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   # XXX figure out how to get "-std=c++17 -fno-rtti" from LLVM.  That's how we
@@ -192,13 +187,11 @@
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=non-template-friend")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=non-template-friend")
   endif()
-  iF(SUPPORTS_DEPRECATED_DECLARATIONS)
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=deprecated-declarations")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=deprecated-declarations")
-  endif()
 
   set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
   set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELEASE} -O3 -g")
+elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /std:c++17 /GR-")
 endif()
 
 ###############################################################################

=== debian/changelog ===
cvise (2.10.0+20240909-1) unstable; urgency=medium

  * New upstream snapshot.
  * Build using LLVM 19.

 -- Matthias Klose <doko@debian.org>  Mon, 09 Sep 2024 17:25:52 +0200

cvise (2.10.0-2) unstable; urgency=medium

  * Drop build dependency on python-pytest-flake8 (Olivier Gayot).

 -- Matthias Klose <doko@debian.org>  Mon, 15 Apr 2024 15:47:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: cvise
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
+Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper-compat (= 12),
   dh-python,
@@ -14,8 +13,8 @@
   python3-pebble,
   python3-psutil,
   python3-pytest <!nocheck>,
-  llvm-18-dev, libclang-18-dev, clang-18, clang-format-18,
-#  clang-tools-18, clang-tidy-18, clangd-18,
+  llvm-19-dev, libclang-19-dev, clang-19, clang-format-19,
+#  clang-tools-19, clang-tidy-19, clangd-19,
   unifdef,
 Standards-Version: 4.6.2
 Homepage: https://github.com/marxin/cvise
@@ -23,7 +22,7 @@
 Package: cvise
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
-  clang-format-18,
+  clang-format-19,
   python3,
   python3-chardet,
   python3-pebble,
